dofile("add-ons/server_admin/tableFileIO.lua")

function checkForTarget(client,target)
	c = getClientByName(target)
	if c == nil then
		client:sendMessage("[colour='FFFF0000']No client by that name found!","error")
		return nil
	end
	p = c:getPlayer()
	if p == nil then
		client:sendMessage("[colour='FFFF0000']That client did not have a player!","error")
		return nil
	end
	return p
end

function adminCommand(client,command,argument)

	if command == "/startRace" or command == "/startrace" then
		preStartRace()
		return
	end
	
	if command == "/endRace" or command == "/endrace" then
		endRace()
		return
	end
	
	if command == "/ping" then
		target = getClientByName(argument)
		if target == nil then
			client:sendMessage("[colour='FFFF0000']No client by that name!","error")
		else
			client:sendMessage(target:getPing() .. "ms","server")
		end
		return
	end

	if command == "/fetch" then
		ourPlayer = client:getPlayer()
		if ourPlayer == nil then
			client:sendMessage("[colour='FFFF0000']You need a player to do this!","error")
			return
		end
		
		target = checkForTarget(client,argument)
		if target then
			target:setPosition(ourPlayer:getPosition())

			for i=0,getNumBrickCars()-1,1 do
				car = getBrickCarIdx(i)
				if car then
					if car:getDriver() ~= nil then
						if car:getDriver():getPlayer() ~= nil then
							if car:getDriver():getPlayer() == target then
								car:setPosition(ourPlayer:getPosition())
							end
						end
					end
				end
			end
		end
	end

	if command == "/find" then
		ourPlayer = client:getPlayer()
		if ourPlayer == nil then
			client:sendMessage("[colour='FFFF0000']You need a player to do this!","error")
			return
		end
		
		target = checkForTarget(client,argument)
		if target then
			ourPlayer:setPosition(target:getPosition())
		end
	end
	
	if command == "/spy" then
		ourPlayer = client:getPlayer()
		if ourPlayer ~= nil then
			camTarget = client:getCameraTarget()
			if camTarget ~= nil then
				if camTarget ~= ourPlayer then
					client:bindCamera(ourPlayer)
					return
				end
			end
		end
	
		target = checkForTarget(client,argument)
		print(target)
		if target then
			client:bindCamera(target)
		end
	end
	
	if command == "/mute" then
		target = getClientByName(argument)
		
		if target == nil then
			client:sendMessage("[colour='FFFF0000']No client by that name!","error")
			return
		end
		
		if muteTable[target.id] then
			client:sendMessage("[colour='FFFF0000']They are already muted!","error")
			return
		end
		
		if hasAdmin(target) then
			client:sendMessage("[colour='FFFF0000']You may not mute a fellow admin!","error")
			return
		end
		
		muteTable[target.id] = true
		playSound("Admin")
		messageAll("[colour='FFFFFF00']" .. client:getName() .. " [colour='FF00FF00']has muted [colour='FFFFFF00']" .. target:getName() .. " [colour='FF00FF00']!","server")
		
	end
	
	if command == "/unmute" then
		target = getClientByName(argument)
		
		if target == nil then
			client:sendMessage("[colour='FFFF0000']No client by that name!","error")
			return
		end
		
		if muteTable[target.id] ~= true then
			client:sendMessage("[colour='FFFF0000']They are not muted!","error")
			return
		end
		
		muteTable[target.id] = false
		playSound("Admin")
		messageAll("[colour='FFFFFF00']" .. client:getName() .. " [colour='FF00FF00']has unmuted [colour='FFFFFF00']" .. target:getName() .. " [colour='FF00FF00']!","server")
	
	end
	
	if command == "/kick" then
		target = getClientByName(argument)
		
		if target == nil then
			client:sendMessage("[colour='FFFF0000']No client by that name!","error")
			return
		end
		
		if hasAdmin(target) then
			client:sendMessage("[colour='FFFF0000']You may not kick a fellow admin!","error")
			return
		end
		
		playSound("Admin")
		messageAll("[colour='FFFFFF00']" .. client:getName() .. " [colour='FF00FF00']has kicked [colour='FFFFFF00']" .. target:getName() .. " [colour='FF00FF00']!","server")
		target:kick()
	end
	
	if command == "/clearbricks" or command == "/clearBricks" then
		target = getClientByName(argument)
		
		if target == nil then
			client:sendMessage("[colour='FFFF0000']No client by that name!","error")
			return
		end
		
		if hasAdmin(target) then
			client:sendMessage("[colour='FFFF0000']You may not clear the bricks of a fellow admin!","error")
			return
		end
		
		playSound("Admin")
		messageAll("[colour='FFFFFF00']" .. client:getName() .. " [colour='FF00FF00']has cleared the bricks of [colour='FFFFFF00']" .. target:getName() .. " [colour='FF00FF00']!","server")
		target:clearBricks()
	end
	
	if command == "/clearcars" or command == "/clearCars" then
		target = getClientByName(argument)
		
		if target == nil then
			client:sendMessage("[colour='FFFF0000']No client by that name!","error")
			return
		end
		
		if hasAdmin(target) then
			client:sendMessage("[colour='FFFF0000']You may not clear the cars of a fellow admin!","error")
			return
		end
		
		playSound("Admin")
		messageAll("[colour='FFFFFF00']" .. client:getName() .. " [colour='FF00FF00']has cleared the cars of [colour='FFFFFF00']" .. target:getName() .. " [colour='FF00FF00']!","server")
		
		carsToRemove = {}
		
		for i=0,getNumBrickCars()-1,1 do
			car = getBrickCarIdx(i)
			if car then
				builder = car:getBuilder()
				if builder then
					if builder == target then
						table.insert(carsToRemove,car)
					end
				end
			end
		end
		
		for k,v in pairs(carsToRemove) do
			v:remove()
		end
	end

	if command == "/clearallcars" or command == "/clearAllCars" then
		playSound("Admin")
		messageAll("[colour='FFFFFF00']" .. client:getName() .. " [colour='FF00FF00']has cleared all cars!","server")
		clearAllCars()
	end
	
end

function file_exists(name)
   local f=io.open(name,"r")
   if f~=nil then io.close(f) return true else return false end
end

if adminTable == nil then
	if file_exists("add-ons/server_admin/adminTable.txt") then
		adminTable = table.load("add-ons/server_admin/adminTable.txt")
	else
		adminTable = {}
	end
end

if muteTable == nil then
	muteTable = {}
end

function hasAdmin(client)
	if client:isGuest() then
		return false
	end

	if adminTable[client:getID()] == 1 then
		return true
	else
		return client:hasEvalAccess()
	end
end

function adminChatPackage(client,message)
	if string.sub(message,0,1) == "/" then
		words = {}
		for w in message:gmatch("%S+") do table.insert(words,w) end
		
		if words[1] == "/admin" then
			if client:hasEvalAccess() then
				target = getClientByName(words[2])
				if target == nil then
					client:sendMessage("[colour='FFFF0000']Could not find client by that name!","error")
				else
					if target:isGuest() then
						client:sendMessage("[colour='FFFF0000']You cannot make a guest admin!","error")
					else
						if adminTable[target:getID()] == 1 then
							client:sendMessage("[colour='FFFF0000']That person is already admin!","error")
						else
							adminTable[target:getID()] = 1
							playSound("Admin")
							messageAll("[colour='FFFFFF00']" .. client:getName() .. " [colour='FF00FF00']has made [colour='FFFFFF00']" .. target:getName() .. " [colour='FF00FF00']admin!","server")
							table.save(adminTable,"add-ons/server_admin/adminTable.txt")
						end
					end
				end
			else
				client:sendMessage("[colour='FFFF0000']You need to have eval access to do this!","error")
				return message,true
			end
		end
		
		if words[1] == "/removeCars" or words[1] == "/removecars" then
			carsToRemove = {}
			
			for i=0,getNumBrickCars()-1,1 do
				car = getBrickCarIdx(i)
				if car then
					builder = car:getBuilder()
					if builder then
						if builder == client then
							table.insert(carsToRemove,car)
						end
					end
				end
			end
			
			for k,v in pairs(carsToRemove) do
				v:remove()
			end
			return message,true
		end
		
		if words[1] == "/removeCar" or words[1] == "/removecar" then
			for i=0,getNumBrickCars()-1,1 do
				car = getBrickCarIdx(i)
				if car then
					if car:getDriver() == client then
						if car:getBuilder() == client then
							car:remove()
						else
							client:sendMessage("[colour='FFFF0000']You can only remove cars you built!","error")
						end
						break
					end
				end
			end
			return message,true
		end
		
		if hasAdmin(client) then
			adminCommand(client,words[1],words[2])
			return message,true
		end
	
		return message,true
	else
		if muteTable[client.id] then
			client:sendMessage("[colour='FFFF0000']You have been muted by an admin!","error")
			return message,true
		else
			return message,false
		end
	end
end
registerEventListener("clientChat","adminChatPackage")

function adminOrbPackage(client,startOrStop,cancelled,x,y,z)

	if hasAdmin(client) == false then
		return true,x,y,z
	end

	return cancelled,x,y,z
end
registerEventListener("clientAdminOrb","adminOrbPackage")

function joinPackage(client)
	if client:isGuest() == false then
		if hasAdmin(client) == true then
			playSound("Admin")
			messageAll("[colour='FFFFFF00']" .. client:getName() .. " [colour='FF00FF00']has been made admin (auto)!","server")
		end
	end
end
registerEventListener("clientJoin","joinPackage")